# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#                                     r.employee_id as         'amount_salida': fields.float('Total Salida', readonly=True),
#            GROUP BY p.id ,l.partner_id,l.journal_id,l.create_date,l.amount_total,s.total

##############################################################################

from openerp import tools
from openerp.osv import fields, osv
from openerp.tools.translate import _
from openerp.tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT


class diariocta_analisis(osv.osv):
    _name = "diariocta.analisis"
    _description = "Analisis de Entrada sobre Diario de Cuentas"
    _auto = False

    _columns = {
        'invoice_id': fields.char('N°Ref Cobro', readonly=True),
        'partner_id': fields.many2one('res.partner', 'Partner', readonly=True),
        'type': fields.char('Tipo', readonly=True),
        'currency_id': fields.many2one('res.currency', 'Moneda', required=True,readonly=True),
        'amount_entrada': fields.float('Total Entrada', readonly=True),
        'date_x': fields.date('Date Order', readonly=True),
    }
    _order = 'date_x desc'


    def init(self, cr):
            tools.sql.drop_view_if_exists(cr, 'diariocta_analisis')
            cr.execute("""
                CREATE OR REPLACE VIEW diariocta_analisis AS (
                   SELECT l.id as id,
                           r.name as invoice_id,
                           l.partner_id as partner_id,
                           l.type as type,
                           l.payment_rate_currency_id as currency_id,
                           l.amount AS amount_entrada,
                           l.date as date_x
                    FROM account_move r
                        left join account_voucher l on (r.id=l.move_id)
                             left join account_voucher_line p on (p.voucher_id=l.id)

                    WHERE l.state='posted' and l.amount>0 and l.type='receipt'

                )
             """)
diariocta_analisis()
